﻿
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.HashSet;
import java.util.*;

import java.io.*;

import java.lang.IndexOutOfBoundsException;

public class PW_ArrayList2 extends JFrame implements ActionListener {

  JButton bntest1 = new JButton("test1 (SimpleArrayList)");
  JButton bntest2 = new JButton("test2: speedtest");
  JButton bntest3 = new JButton("test3: toStringFromLast");
  JButton bntest4 = new JButton("test4: lotto (ArrayLIst)");
  JButton bntest5 = new JButton("test5: Lotto HashSet");
  JButton bntest6 = new JButton("test6: create Namen.txt");
  JButton bntest7 = new JButton("test7: read Namen.txt:ArrayList");
  JButton bntest8 = new JButton("test8: read Namen.txt: HashMap");
  JButton bnClose = new JButton("Close");
  JTextArea editor = new JTextArea();

  public PW_ArrayList2() {
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    setGUI();
  }

  private void setGUI() {
    setSize(700, 450);
    setTitle("ArrayList");

    this.getContentPane().setLayout(new BorderLayout());

    JPanel panelBn = new JPanel();
    panelBn.setLayout(new GridLayout(9,1) );
    panelBn.add(bntest1);
    panelBn.add(bntest2);
    panelBn.add(bntest3);
    panelBn.add(bntest4);
    panelBn.add(bntest5);
    panelBn.add(bntest6);
    panelBn.add(bntest7);
    panelBn.add(bntest8);
    panelBn.add(bnClose);

   this.getContentPane().add(panelBn, BorderLayout.EAST);

   this.getContentPane().add(new JScrollPane(editor), BorderLayout.CENTER);

    editor.setFont(new Font("Arial", Font.PLAIN, 18));

    setFonts(getContentPane(), 16);

    bntest1.addActionListener(this);
    bntest2.addActionListener(this);
    bntest3.addActionListener(this);
    bntest4.addActionListener(this);
    bntest5.addActionListener(this);
    bntest6.addActionListener(this);
    bntest7.addActionListener(this);
    bntest8.addActionListener(this);
    bnClose.addActionListener(this);

  } // setGUI

  private void setFonts(Container cont, int size) {
    for (int i = 0; i < cont.getComponentCount(); i++) {
      Component c = cont.getComponent(i);
      if (c instanceof JPanel) {
        setFonts((JPanel) c, size);
      } else {
        c.setFont(new Font("Arial", Font.BOLD, size));
      }
    }
  }  // setFonts

  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == bntest1) 
      test1();
    else if (e.getSource() == bntest2) 
            test2();
            else if (e.getSource() == bntest3) 
            test3();
            else if (e.getSource() == bntest4) 
                test4();
            else if (e.getSource() == bntest5) 
               test5();
             else if (e.getSource() == bntest6) 
               test6();
             else if (e.getSource() == bntest7) 
               test7();
             else if (e.getSource() == bntest8) 
               test8();
            else  if (e.getSource() == bnClose) 
              System.exit(0);
            else System.err.println("error");
  }

  
  private void test1() {    
    SimpleArrayList liste = new SimpleArrayList();
    for (int i=0; i<4000; i++) {
      liste.add("Item "+i);
    }
    editor.setText("n:"+liste.size());
    for (int i=0; i<liste.size(); i++) {
      editor.append( liste.get(i) +"\n" );
    }
    //editor.setText("alles okay");
  }  // test1


  private void test2() {
    int max=50000;
    long t1, t2;
    SimpleArrayList  liste1 = new SimpleArrayList();
    editor.setText("Test SimpleArrayList add\n");
    t1 = System.nanoTime();
    for (int i=0; i<max; i++) {
       liste1.add(i    ); 
    }
    t2 = System.nanoTime();
    editor.append("Zeit SimpleArrayList add: "+(t2-t1)+"\n" );

    SimpleArrayList  liste1a = new SimpleArrayList(max);
    editor.append("Test SimpleArrayList add\n");
    t1 = System.nanoTime();
    for (int i=0; i<max; i++) {
       liste1a.add(i    ); 
    }
    t2 = System.nanoTime();
    editor.append("Zeit SimpleArrayList add(max): "+(t2-t1)+"\n" );
    
    
    ArrayList  liste2 = new ArrayList();
    editor.append("Test ArrayList add\n");
    t1 = System.nanoTime();
    for (int i=0; i<max; i++) {
       liste2.add(i    ); 
    }
    t2 = System.nanoTime();
    editor.append("Zeit ArrayList add: "+(t2-t1)+"\n" );
    
  } // test2
  
  
  private void test3() {
    SimpleList liste = new SimpleList();
    liste.addLast( new Integer(12) );
    liste.addLast( new Integer(15) );
    liste.addFirst( new Integer(42) );
    liste.addLast( new Integer(5) );
    liste.addFirst( new Integer(-42) );
    System.out.println(liste.toStringFromLast());
  }

  private void test4() {
    editor.setText("test4");
    ArrayList<Integer> liste = new ArrayList();
    while (liste.size() <6) {
     
      int num=(int) (Math.random()*7)+1;
      boolean gefunden=false;
      for(int zahl:liste) {
        if (zahl==num) {
          gefunden=true;
          break;
        }
      } // for
      if (!gefunden)
        liste.add(num);
      else
         System.out.println("--");
    }
    System.out.println(liste);
  }
  
  private void test5() {
    editor.setText("test5\n");
     HashSet<Integer> liste = new HashSet();
    lotto(liste);
    TreeSet<Integer> liste2 = new TreeSet();
    lotto(liste2);
    int min = liste2.first();
    int max = liste2.last();
     editor.append(liste2.toString());
    editor.append("\nmin: "+min+"   max:"+max+"\n");
    SortedSet sort = liste2.headSet(6); // <6
    editor.append(sort.toString()+"\n");
    sort = liste2.tailSet(6);// >=6
    editor.append(sort.toString());
  }

    private void lotto(Set liste) {
    while (liste.size() <6) {
      int num=(int) (Math.random()*17)+1;
      if (!  liste.add(num) )
        editor.append("in liste vorhanden\n");
    }
    System.out.println(liste);
  }
  
  
  String longToStr0(long value, int n) {
    String erg = Long.toString(value);
    while( erg.length()<n)  erg="0"+erg;
    return erg;
  }
  
  
  // Matrnr_1_Vorname
  // Matrnr_2_Nachname
  // shuffle
  private void test6() {    // create Nanmen.txt() {
    int max = 10000;
    List<String> liste = new ArrayList<String>(max <<1);
    for (int i=100; i<max+100; i++) {
      liste.add(  longToStr0(i,6)+" 1 "+"Vorname"+(i+1) );
      liste.add(  longToStr0(i,6)+" 2 "+"Nachname"+(i+1) );
    }
    Collections.shuffle(liste);
    editor.setText("create Nanmen.txt");
    try {
         FileOutputStream Fout = new FileOutputStream("namen.txt"); 
         PrintStream p = new PrintStream(Fout);  
         for(String s : liste) {
           editor.append(s+"\n");
           p.println(s);
        }
       p.close();
     }
       catch (IOException e) {
           System.err.println("IOException: " + e);
       }
    System.out.println("ende");
  }
  
  
  // read namen.txt
  private void test7() {    
    FileInputStream fin;
    InputStreamReader iin;
    LineNumberReader din;
    BufferedInputStream bin;
    String line;
    String mnr, typ;
    Student std;
    int matrnr;
    String name;

    ArrayList<Student> array;
    
    long t1, t2;
    t1 = System.currentTimeMillis();
    try {
      fin = new FileInputStream("namen.txt");
      bin = new BufferedInputStream(fin);
      iin = new InputStreamReader(bin);
      din = new LineNumberReader(iin);  // oder BufferedReader br = new BufferedReader(ir);
        line = din.readLine();
        int n = Integer.parseInt(line);
        
        array = new  ArrayList(n);
        
        for (int i=0; i<n<<1;  i++) {
           line = din.readLine();
           mnr = line.substring(0,6);  // von 0 bis 5, 6 zaehlt nicht mehr dazu
           typ = line.substring(7,8);  // von 7 bis 7, 8 zaehlt nicht mehr dazu
           matrnr = Integer.parseInt(mnr);
           std = new Student(matrnr);
           boolean gefunden=false;
           for (Student std2:array) {
             if (std2.matrnr==matrnr) {
               std=std2;
               gefunden=true;
               break;
             }
           }           
           if (!gefunden) {             
             array.add(std);
           }
           if (typ.equals("1"))
            std.vname = line.substring(9);         
           else
            std.nname = line.substring(9);                    
        }
      t2 = System.currentTimeMillis();
      editor.append("ArrayList Zeit:   "+(t2-t1)+" ms\n" );  // Prüfung und sortieren
      System.out.println("ArrayList Zeit:   "+(t2-t1)+" ms\n" );  // Prüfung und sortieren
        
       for (Student std2:array) {
           editor.append(std2+"\n");
        }         
    }
     catch (FileNotFoundException e1) {
         System.err.println("Datei war nicht vorhanden!");
    }
    catch (IOException ee) {
           System.err.println("IOException: " + ee);
    }
    
  }  // test7
  
  
  // read namen.txt
  private void test8() {    
    FileInputStream fin;
    InputStreamReader iin;
    LineNumberReader din;
    BufferedInputStream bin;
    String line;
    String mnr, typ;
    Student std;
    int matrnr;
    String name;

    HashMap array;
    
    long t1, t2;
    t1 = System.currentTimeMillis();
    try {
      fin = new FileInputStream("namen.txt");
      bin = new BufferedInputStream(fin);
      iin = new InputStreamReader(bin);
      din = new LineNumberReader(iin);  // oder BufferedReader br = new BufferedReader(ir);
        line = din.readLine();
        int n = Integer.parseInt(line);
        
        array = new HashMap(n, 0.70f);
        
        for (int i=0; i<n<<1;  i++) {
           line = din.readLine();
           mnr = line.substring(0,6);  // von 0 bis 5, 6 zaehlt nicht mehr dazu
           typ = line.substring(7,8);  // von 7 bis 7, 8 zaehlt nicht mehr dazu
           matrnr = Integer.parseInt(mnr);
           std = (Student) array.get(matrnr);  // test, ob schon in der Liste
           if (std==null) {
             std = new Student(matrnr);
             array.put(matrnr,std);
           }
           if (typ.equals("1"))
            std.vname = line.substring(9);         
           else
            std.nname = line.substring(9);                    
        }
        t2 = System.currentTimeMillis();
        System.out.println("HashSet Zeit:   "+(t2-t1)+" ms\n" );  // Prüfung und sortieren
        editor.append("HashSet Zeit:   "+(t2-t1)+" ms\n" );  // Prüfung und sortieren
        
        // nun werden die Werte ausgegeben
        if ( YesNo("Ausgabe","Wollen Sie eine sortierte Ausgabe?")  ) {
          // holen aller Werte, speichern in eine List
          List<Student> liste = new ArrayList<Student>(array.values());
          Collections.sort(liste);                    
          for (Student std2 : liste) {
            editor.append(std2+"\n");
          }
        }
        else {
          Set<Integer> keys = array.keySet();
          for (Integer key : keys) {
            std = (Student) array.get(key);
            editor.append(std+"\n");
          }
        }
    }
     catch (FileNotFoundException e1) {
         System.err.println("Datei war nicht vorhanden!");
    }
    catch (IOException ee) {
           System.err.println("IOException: " + ee);
    }
    
  }  // test8
  
  public boolean YesNo( String sTitle, String sMessage) {
    int retcode;
    retcode = JOptionPane.showConfirmDialog(null,sMessage,sTitle,
      JOptionPane.YES_NO_OPTION,
      JOptionPane.QUESTION_MESSAGE);  // Symbol

    switch (retcode) {
       case JOptionPane.YES_OPTION:
         // ja, Änderungen speichern
         return true;
       case JOptionPane.NO_OPTION:
         return false;
       case JOptionPane.CANCEL_OPTION:
       default:
         // abbrechen
         return false;
    }
  } // YesNo


  
  public static void main(String[] args) {
    PW_ArrayList2 frame = new PW_ArrayList2();
    frame.setVisible(true);
  }
}


